# NOTE: this program may take a few minuts to fully run. Please be patient and wait for two images!
# Name of image file to be generated. Should include label for image and color manipulation.

myname = "ImageName R + B"


# IMPORT LIBRRIES

# Import standard libraries

import os,sys,io

# Import Image library from PIL

from PIL import Image


# OPEN SOURCE IMAGE

# Call Image.open function (with image name as parameter) then assign it ot source_image variable.

source_image = Image.open("/Users/markciotola1/Programs/python/Image_Processing/syria_fields_Google_2017_06_23_ex.png")

# Print some metadata about the source file.

print(source_image.format, source_image.size, source_image.mode)

# Read image data from the file.

pix = source_image.load()

# Display the source image.

source_image.show()



# PERFORM PROCESSING AND ANALYSIS

print "Performing processing and analysis."

# Positioning parameters (if needed)

offset = 0.0

myoff = 0.0

redstart = 0

# Create new image for results

result_image = Image.new("RGB", [source_image.width,source_image.height], color=0)

# Loop through each pixel and process it, row by row.

for y in range(0, source_image.height): #each pixel has coordinates
    
    for x in range(0, source_image.width):
        
        # Make choice how to combine color bands to attempt identify required feature(s).
        # This combination really emphasizes blue reflection while penalizing red (e.g. bare soil).
        # It emphasizes urban areas.
        # It may also might be a rough indicature of soil moisture (note lighter area near river).
        mycalc =  (5 * pix[x,y][2]) - (2 * pix[x,y][0]) - pix[x,y][1]
        
        # More examples
        # mycalc = pix[x,y][1] - pix[x,y][2]
        # mycalc = pix[x,y][1] / pix[x,y][2]
        # mycalc = pix[x,y][1] * pix[x,y][2]
        # Etc.
        
        # Results combined to produce monochrome, but brighter image.
        # Monochone image is easier for further analysis.
        result_image.putpixel( (x, y), ( mycalc, mycalc, mycalc  ))

# Display result image.

result_image.show()

# Display selected image paramaters if desired.
# print y
# print myoff

# Save result image.
result_image.save("/Users/markciotola1/Programs/python/Image_Processing/mypic1"+str(myname)+".jpg")


# REFERENCES

# Program by SustainSat.com

# https://pillow.readthedocs.org/en/latest/reference/Image.html#image-processing

# http://pythontips.com/2013/07/30/20-python-libraries-you-cant-live-without/



